%{
/* lexical analizer for [ascr]asm series ver.1.0 ['92/Aug./25] */

#include <string.h>
#include <math.h>
#include <ctype.h>
#include "const.h"
#include "y.tab.h"
#define	HEXSTRLEN	10
#define	BINSTRLEN	34
#define LINESIZE	255
#define STRSIZE	64

extern void	lexerror();
extern void	addline();
extern void	allupper();
extern int	htoi();
extern int	btoi();

int strcnt = 0;
char	string[STRSIZE + 1] = {0};

int lineptr = 0;
char	linebuff[LINESIZE + 1] = {0};

%}
A	[Aa]
B	[Bb]
C	[Cc]
D	[Dd]
E	[Ee]
F	[Ff]
G	[Gg]
H	[Hh]
I	[Ii]
J	[Jj]
K	[Kk]
L	[Ll]
M	[Mm]
N	[Nn]
O	[Oo]
P	[Pp]
Q	[Qq]
R	[Rr]
S	[Ss]
T	[Tt]
U	[Uu]
V	[Vv]
W	[Ww]
X	[Xx]
Y	[Yy]
Z	[Zz]
DECIMAL		[0-9]
NZDECIMAL	[1-9]
HEXA		[0-9A-Fa-f]
EXP	({E}[+-]?{DECIMAL}+)
%e 2000
%p 4000
%a 3000
%start COMMENT STR
%%
<INITIAL>{L}{D}{I}	{
			addline(yytext);
			return(LDI);
			}
<INITIAL>{L}{D}		{
			addline(yytext);
			return(LD);
			}
<INITIAL>{S}{T}{I}	{
			addline(yytext);
			return(STI);
			}
<INITIAL>{S}{T}		{
			addline(yytext);
			return(ST);
			}
<INITIAL>{P}{U}{S}{H}	{
			addline(yytext);
			return(PUSH);
			}
<INITIAL>{P}{O}{P}	{
			addline(yytext);
			return(POP);
			}
<INITIAL>{P}{U}{S}{H}{I}	{
			addline(yytext);
			return(PUSHI);
			}
<INITIAL>{A}{D}{D}	{
			addline(yytext);
			return(ADD);
			}
<INITIAL>{A}{D}{D}{I}	{
			addline(yytext);
			return(ADDI);
			}
<INITIAL>{S}{U}{B}	{
			addline(yytext);
			return(SUB);
			}
<INITIAL>{S}{U}{B}{I}	{
			addline(yytext);
			return(SUBI);
			}
<INITIAL>{M}{U}{L}	{
			addline(yytext);
			return(MUL);
			}
<INITIAL>{M}{U}{L}{I}	{
			addline(yytext);
			return(MULI);
			}
<INITIAL>{D}{I}{V}	{
			addline(yytext);
			return(DIV);
			}
<INITIAL>{D}{I}{V}{I}	{
			addline(yytext);
			return(DIVI);
			}
<INITIAL>{M}{O}{D}	{
			addline(yytext);
			return(MOD);
			}
<INITIAL>{M}{O}{D}{I}	{
			addline(yytext);
			return(MODI);
			}
<INITIAL>{A}{N}{D}	{
			addline(yytext);
			return(AND);
			}
<INITIAL>{A}{N}{D}{I}	{
			addline(yytext);
			return(ANDI);
			}
<INITIAL>{O}{R}		{
			addline(yytext);
			return(OR);
			}
<INITIAL>{O}{R}{I}	{
			addline(yytext);
			return(ORI);
			}
<INITIAL>{X}{O}{R}	{
			addline(yytext);
			return(XOR);
			}
<INITIAL>{X}{O}{R}{I}	{
			addline(yytext);
			return(XORI);
			}
<INITIAL>{N}{E}{G}	{
			addline(yytext);
			return(NEG);
			}
<INITIAL>{N}{O}{T}	{
			addline(yytext);
			return(NOT);
			}
<INITIAL>{N}{E}{G}{I}	{
			addline(yytext);
			return(NEGI);
			}
<INITIAL>{N}{O}{T}{I}	{
			addline(yytext);
			return(NOTI);
			}
<INITIAL>{O}{R}{G}	{
			addline(yytext);
			return(ORG);
			}
<INITIAL>{E}{Q}{U}	{
			addline(yytext);
			return(EQU);
			}
<INITIAL>{D}{W}	{
		addline(yytext);
		return(DW);
		}
<INITIAL>{D}{S}	{
		addline(yytext);
		return(DS);
		}
<INITIAL>{N}{O}{P}	{
		addline(yytext);
		return(NOP);
		}
<INITIAL>{H}{L}{T}	{
		addline(yytext);
		return(HLT);
		}
<INITIAL>{M}{O}{V}	{
		addline(yytext);
		return(MOV);
		}
<INITIAL>"#"	{
		addline(yytext);
		return(IMMED);
		}
<INITIAL>"="	{
		addline(yytext);
		return(EQU);
		}
<INITIAL>"+"	{
		addline(yytext);
		return(ADDOP);
		}
<INITIAL>"-"	{
		addline(yytext);
		return(SUBOP);
		}
<INITIAL>"*"	{
		addline(yytext);
		return(MULOP);
		}
<INITIAL>"/"	{
		addline(yytext);
		return(DIVOP);
		}
<INITIAL>"%"	{
		addline(yytext);
		return(MODOP);
		}
<INITIAL>"&"	{
		addline(yytext);
		return(ANDOP);
		}
<INITIAL>"|"	{
		addline(yytext);
		return(OROP);
		}
<INITIAL>"^"	{
		addline(yytext);
		return(XOROP);
		}
<INITIAL>"~"	{
		addline(yytext);
		return(NOTOP);
		}
<INITIAL>">>"	{
		addline(yytext);
		return(RSFTOP);
		}
<INITIAL>"<<"	{
		addline(yytext);
		return(LSFTOP);
		}
<INITIAL>"("	{
		addline(yytext);
		return(LP);
		}
<INITIAL>")"	{
		addline(yytext);
		return(RP);
		}
<INITIAL>":"	{
		addline(yytext);
		return(COLON);
		}
<INITIAL>","	{
		addline(yytext);
		return(COMMA);
		}
<INITIAL>\n	{
		addline(yytext);
		yylval.charptr = linebuff;
		lineptr = 0;
		return(NL);
		}
<INITIAL>";"	{
		addline(yytext);
		BEGIN COMMENT;
		}
<INITIAL>{R}{DECIMAL}	|
<INITIAL>{R}{DECIMAL}{DECIMAL}	|
<INITIAL>{R}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[1]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > MAXREG)) {
					lexerror("invalid register number");
					yylval.intvalue = 0;
				}
				return (REG);
				}
<INITIAL>[_A-Za-z][_A-Za-z0-9]*	{
				yylval.charptr = strdup(yytext);
				allupper(yylval.charptr);
				addline(yytext);
				return (LABEL);
				}
<INITIAL>{DECIMAL}+		{
				yylval.intvalue = atoi(yytext);
				addline(yytext);
				return (INTVAL);
				}
<INITIAL>{DECIMAL}{HEXA}*[hH]	{
				addline(yytext);
				if (htoi(yytext,&yylval.intvalue)==0) {
					return (INTVAL);
				} else { /* hexadecimal str too long */
					lexerror("too long hexadecimal const.");
					return (INTVAL);
				}
				}
<INITIAL>[01]+[bB]		{
				addline(yytext);
				if (btoi(yytext,&yylval.intvalue)==0) {
					return (INTVAL);
				} else { /* binary str too long */
					lexerror("too long binary const.");
					return (INTVAL);
				}
				}
<INITIAL>[ \t]	{
		addline(yytext);
		}
<INITIAL>.	{
		addline(yytext);
		lexerror("invalid character");
		}
<COMMENT>.	{
		addline(yytext);
		}
<COMMENT>\n	{
		addline(yytext);
		yylval.charptr = linebuff;
		lineptr = 0;
		BEGIN INITIAL;
		return(NL);
		}
%%
/* printout lex errormessage */
void lexerror(s)
char *s;
{
	extern int yynerrs, yylineno;

	++yynerrs;
	fprintf(stderr,"%d: %s\n",yylineno,s);
}

/* append to linebuff */
void addline(str)
char *str;
{
	int	i;
	extern 	int	lineptr;

	for (i = 0 ; i < strlen(str) ; i++) {
		linebuff[lineptr++] = str[i];
	}

	linebuff[lineptr] = (char)NULL;
}

/* convert hexadecimal string to integer */
int htoi(cp,retval)
char *cp;
int  *retval;
{	
	char	tmp[HEXSTRLEN];
	int	slen;

	if ((slen = strlen(cp)) > HEXSTRLEN) {
		*retval = 0;
		return (-1);
	}
	
	strncpy(tmp,cp,slen-1);
	tmp[slen] = (char)NULL;

	*retval = (int)strtol(tmp,(char **)NULL,16);
	return (0);
}

/* convert binary string to integer */
int btoi(cp,retval)
char *cp;
int  *retval;
{	
	char	tmp[BINSTRLEN];
	int	slen;

	if ((slen = strlen(cp)) > BINSTRLEN) {
		*retval = 0;
		return (-1);
	}
	
	strncpy(tmp,cp,slen-1);
	tmp[slen] = (char)NULL;

	*retval = (int)strtol(tmp,(char **)NULL,2);
	return (0);
}

/* convert string to uppercase */
void allupper(cp)
char *cp;
{
	int	i;

	for (i = 0 ; i < strlen(cp) ; i++) {
		cp[i] = toupper(cp[i]);
	}
}
