/* defines and global variables for rasm ver.1.0 ['93/Aug/26] */

#include "global.h"

#define	TRUE	1
#define FALSE	0

/* define architecture */
#define RISC_ARCH

/* word union (short & unsigned short) */
typedef union {
	short	s;
	unsigned short	us;
} word ;

/* label node struct */
struct l_node {
	char *labelname;
	int	labelvalue;
	int	initialized;
	struct l_node *next;
} ;

typedef struct l_node labelnode;

global labelnode *root init((labelnode *)NULL);

/* label control functions */
extern labelnode *labelnodealloc();
extern labelnode *addlabel();
extern labelnode *addlabelandinit();
extern int	 getlabelvalue();

/* enable uninitialized label used error flag default value*/
global	int	uninitlabelerrdefault init(FALSE);

/* assemble pass */
global	int	pass init(1);

/* current PC */
global	int     currentpc init(0);

/* DW pseudo instruction counter's maxlen & buffer */
global	int	maxdwc init(0);
global 	int	*dwbuff;

/* listing file output */
extern	void	listoutwithinst();
extern	void	listoutwithpc();
extern	void	listoutcmnt();
extern	void	listoutlabellist();

/* object file output */
extern	void	objectaddrout();
extern	void	objectout();
