/* main program for asm3v ver.1.0 ['92/Aug/8-Aug/11] */
/* 			  ver.1.1 ['92/Aug/22] */
/* 			  ver.1.3 ['92/Sep/1-2] */

#define	MAINPROGRAM

#include <stdio.h>
#include "defines.h"
#include "const.h"

FILE	*source,*list,*object;
extern	FILE	*yyin;
extern	int	yyparse();
extern	int	yylineno;
extern	int	yynerrs;

main(argc,argv)
int	argc;
char 	**argv;
{
	char	basename[256];
	char	sourcename[256];
	char	listname[256];
	char	objectname[256];

	if (argc == 2) {
		if (strcmp(&argv[1][strlen(argv[1])-4],".asm") == 0) {
			strncpy(basename,argv[1],strlen(argv[1])-4);
			basename[strlen(argv[1])-4] = (char) NULL;
		} else {
			strcpy(basename,argv[1]);
		}
		strcpy(sourcename,basename);
		strcat(sourcename,".asm");
		strcpy(listname,basename);
		strcat(listname,".lst");
		strcpy(objectname,basename);
		strcat(objectname,".obj");
	} else {
		fprintf(stderr,"usage: %s soucefilename\n",argv[0]);
		exit(1);
	}

	if ((source = fopen(sourcename,"r")) == NULL) {
		fprintf(stderr,"sourcefile %s open failed\n",sourcename);
		exit(1);
	}
	
	if ((object = fopen(objectname,"w")) == NULL) {
		fprintf(stderr,"objectfile %s open failed\n",objectname);
		exit(1);
	}
	
	if ((list = fopen(listname,"w")) == NULL) {
		fprintf(stderr,"listfile %s open failed\n",listname);
		exit(1);
	}

	yyin = source;

	/* pass 1 */

	pass = 1;
	currentpc = 0;
	uninitlabelerrdefault = FALSE;

	yyparse();

	if (yynerrs != 0) {
		fprintf(stderr,"%d error(s) found in pass 1. aborted.\n",yynerrs);
		exit(1);
	} else {
		fprintf(stderr,"no error found in pass 1.\n");
	}

	rewind(yyin);

	/* pass 2 */

	dwbuff = (int *)malloc((sizeof (int)) * maxdwc);

	pass = 2;
	currentpc = 0;
	uninitlabelerrdefault = TRUE;
	yylineno = 0;

	yyparse();

	if (yynerrs != 0) {
		fprintf(stderr,"%d error(s) found in pass 2. aborted.\n",yynerrs);
		exit(1);
	} else {
		fprintf(stderr,"no error found in pass 2.\n");
	}

	listoutlabellist();	/* output label list */

	fclose(source);
	fclose(object);
	fclose(list);
	
	exit(0);
}

void objectaddrout(addr)
int	addr;	/* instruction address */
{
	if (object != NULL) {
		fprintf(object,":%04X\n",addr & 0xffff);
	}
}

void objectout(inst)
int	inst;	/* instruction word */
{
	if (object != NULL) {
		fprintf(object,"%04X\n",inst & 0xffff);
	}
}

void listoutwithinst(pc,instlen,inst,line)
int	pc;	/* program counter */
int	instlen;/* instruction length */ 
int	*inst;	/* instruction words */
char	*line;	/* source line */
{
	if (list != NULL) {
	    switch (instlen) {
		case 1: fprintf(list," %04X  %04X             %s",
				     pc & 0xffff,
				     (*inst) & 0xffff,
				     line);
			break;
		case 2: fprintf(list," %04X  %04X %04X        %s",
				     pc & 0xffff,
				     (*inst) & 0xffff,
				     (*(inst+1)) & 0xffff,
				     line);
			break;
		case 3: fprintf(list," %04X  %04X %04X %04X   %s",
				     pc & 0xffff,
				     (*inst) & 0xffff,
				     (*(inst+1)) & 0xffff,
				     (*(inst+2)) & 0xffff,
				     line);
			break;
		default: fprintf(stderr,"Wrong listoutwithinst output instruction length(%d).: %s\n",instlen,line);
			 exit(-1);
			 break;
	    }
	}
}

void listoutwithpc(pc,line)
int	pc;	/* program counter */
char	*line;	/* source line */
{
	if (list != NULL) {
		fprintf(list," %04X                   %s",
			     pc & 0xffff,line);
	}
}

void listoutequ(value,line)
int	value;	/* label value */
char	*line;	/* source line */
{
	if (list != NULL) {
		fprintf(list,"       %04X             %s",
			     value & 0xffff,line);
	}
}

void listoutcmnt(line)
char	*line;	/* source line */
{
	if (list != NULL) {
		fprintf(list,"                        %s",line);
	}
}

void listoutlabellist()
{
	int	count;
	labelnode *lnp;

	count = 0;
	lnp = root;

	if ((list != NULL)&&(lnp != NULL)) {
		fprintf(list,"\n\n\nLABELS:\n\n");
		while (lnp != NULL) {
			fprintf(list,"%04X %-13.13s  ",
				(lnp->labelvalue) & 0xffff,
				lnp->labelname);
			if ((++count % 3)==0) fprintf(list,"\n");
			lnp = lnp->next;
		}
		fprintf(list,"\n");
	}
}
