/* various arcitecture simulator ver.1.0 [92/Aug/25-] */

/* define opcode constants */

/* opcode defines */

/* instruction type */

#define LOADSTORE	0	/* load / store  memory */

#define INTCALC2	1	/* integer op. */
#define INTCALC1	2	/* unary integer op. */
#define MISC		3	/* NOP/HLT */

/* operand immediate/register/memory flag */

#ifdef ACCUM_ARCH
#define MEMOPR	0	/* register operand */
#define IMMOPR	1	/* immediate operand */
#endif

#ifdef STACK_ARCH
#define MEMOPR	0	/* register operand */
#define IMMOPR	1	/* immediate operand */
#endif

#ifdef CISC_ARCH
#define REGOPR	0	/* register operand */
#define MEMOPR	1	/* register operand */
#define IMMOPR	2	/* immediate operand */
#endif

#ifdef RISC_ARCH
#define REGOPR	0	/* register operand */
#define IMMOPR	1	/* immediate operand */
#endif

/* LOAD/STORE instruction */

#ifndef STACK_ARCH
/* accumlator, cisc, risc architecture */
#define LS_LOAD		0	/* load from memory, write to REG. */
#define LS_STORE	1	/* store to memory, read from REG. */
#else
/* stack architecture */
#define LS_PUSH		0	/* load from memory, push to STACK */
#define LS_POP		1	/* store to memory, pop from STACK */
#endif

/* integer operation */
#define OP_ADD	0
#define OP_SUB	1
#define OP_MUL	2
#define OP_DIV	3

#define OP_AND	4
#define OP_OR	5
#define OP_XOR	6
#define OP_MOD	7	/* modulo operation */

/* unary integer operation */
#define UOP_NEG	0	/* negation */
#define UOP_NOT	1	/* logical NOT */

/* misc. instruction */
#define MISC_NOP 0
#define MISC_HLT 1
