/* code generation for accumlator architecture */
#include <stdio.h>
#include "defines.h"

typedef struct {
	int	type;
	int	num;
} TMP ;

#ifndef SIMPLETMP
#define MAXTMP 50
static int called=FALSE;
static int tmpuse[MAXTMP];
#endif

code_gen(node)
struct node *node;
{
	TMP	t;
	char 	op[10];
	
	switch (node->w.type) {
	    case SYMBOL:
	    	switch (node->w.symbol) {
	    	    case '=':
	    	    	if ((node->left)->w.type==VARNAME) {
			    switch ((node->right)->w.type) {
				case CONST:
				    printf("\tLDI\t%d\n",
					    (node->right)->w.value);
				    break;
				case VARNAME:
				    printf("\tLD\tVar_%s\n",
					    (node->right)->w.varname);
				    break;
				case SYMBOL:
				    code_gen(node->right);
				    break;
			    }
			    printf("\tST\tVar_%s\n",
			    	    (node->left)->w.varname);
			} else {
			    error("assignment target is not variable.");
			}
	    	    	break;
	    	    case '+':
			strcpy(op,"ADD");
			op_code_gen(op,node->left,node->right);
	    	    	break;
	    	    case '-':
			strcpy(op,"SUB");
			op_code_gen(op,node->left,node->right);
	    	    	break;
	    	    case '*':
			strcpy(op,"MUL");
			op_code_gen(op,node->left,node->right);
	    	    	break;
	    	    case '/':
			strcpy(op,"DIV");
			op_code_gen(op,node->left,node->right);
	    	    	break;
		}
		break;
	    case CONST:
	    case VARNAME:
	    	break;
	}
	return;
}

op_code_gen(op,left,right)
char	*op;
NODE	*left,*right;
{
	TMP	t;

	switch (left->w.type) {
	    case CONST:
		switch (right->w.type) {
		    case CONST: /* leaf op leaf */
			printf("\tLDI\t%d\n",left->w.value);
			printf("\t%sI\t%d\n",op,right->w.value);
			break;
		    case VARNAME: /* leaf op leaf */
			printf("\tLDI\t%d\n",left->w.value);
			printf("\t%s\tVar_%s\n",op,right->w.varname);
			break;
		    case SYMBOL: /* leaf op node */
			code_gen(right);
			get_temp(&t);
			printf("\tST\tTmp_T%d\n",t.num);
			printf("\tLDI\t%d\n",left->w.value);
			printf("\t%s\tTmp_T%d\n",op,t.num);
			temp_free(&t);
			break;
		}
		break;
	    case VARNAME:
		switch (right->w.type) {
		    case CONST: /* leaf op leaf */
			printf("\tLD\tVar_%s\n",left->w.varname);
			printf("\t%sI\t%d\n",op,right->w.value);
			break;
		    case VARNAME: /* leaf op leaf */
			printf("\tLD\tVar_%s\n",left->w.varname);
			printf("\t%s\tVar_%s\n",op,right->w.varname);
			break;
		    case SYMBOL: /* leaf op node */
			code_gen(right);
			get_temp(&t);
			printf("\tST\tTmp_T%d\n",t.num);
			printf("\tLD\tVar_%s\n",left->w.varname);
			printf("\t%s\tTmp_T%d\n",op,t.num);
			temp_free(&t);
			break;
		}
		break;
	    case SYMBOL:
		switch (right->w.type) {
		    case CONST: /* node op leaf */
			code_gen(left);
			printf("\t%sI\t%d\n",op,right->w.value);
			break;
		    case VARNAME: /* node op leaf */
			code_gen(left);
			printf("\t%s\tVar_%s\n",op,right->w.varname);
			break;
		    case SYMBOL: /* node op node */
			code_gen(right);
			get_temp(&t);
			printf("\tST\tTmp_T%d\n",t.num);
			code_gen(left);
			printf("\t%s\tTmp_T%d\n",op,t.num);
			temp_free(&t);
			break;
		}
		break;
	}
}

#ifdef SIMPLETMP
get_temp(t)
TMP	*t;
{
        static int tc = 1;

	t->type = TMPNUM;
	t->num = tc++;
	tmp_touroku(t->num);

}

temp_free(t)
TMP	*t;
{
}
#else
init_temp()
{
	int i;

	for (i = 1 ; i < MAXTMP ; i++) tmpuse[i] = FALSE;
}

get_temp(t)
TMP	*t;
{
	int i;

	if (called == FALSE) {
	    init_temp();
	    called = TRUE;
	}

	for (i = 1 ; i < MAXTMP ; i++) {
	    if (tmpuse[i] == FALSE) {
		tmpuse[i] = TRUE;
		t->type = TMPNUM;
		t->num = i;
		tmp_touroku(t->num);
		return ;
	    }
	}
	error("temp area overflow");
}

temp_free(t)
TMP	*t;
{
	tmpuse[t->num] = FALSE;
}
#endif
