#include <stdio.h>
#include "defines.h"

#define	MAXREGNUM 8

typedef struct {
	int	type;
	int	num;
} TMP ;

#ifndef SIMPLETMP
#define MAXTMP 50
static int called=FALSE;
static int reguse[MAXREGNUM];
static int tmpuse[MAXTMP];
#endif

code_gen(node)
NODE *node;
{
	TMP	t;
	char 	op[10];
	
	switch (node->w.type) {
	    case SYMBOL:
	    	switch (node->w.symbol) {
	    	    case '=':
	    	    	if ((node->left)->w.type==VARNAME) {
			    if ((node->right)->w.type == SYMBOL) {
				code_gen(node->right);
			    }
			    switch ((node->right)->w.type) {
				case CONST:
				    printf("\tST\t#%d,Var_%s\n",
					    (node->right)->w.value,
					    (node->left)->w.varname);
				    break;
				case VARNAME:
				    printf("\tMOV\tVar_%s,Var_%s\n",
					    (node->right)->w.varname,
					    (node->left)->w.varname);
				    break;
				case TMPNUM:
				    t.type = (node->right)->w.type;
				    t.num = (node->right)->w.tmpnum;
				    temp_free(&t);
				    printf("\tMOV\tTmp_T%d,Var_%s\n",
					    (node->right)->w.tmpnum,
					    (node->left)->w.varname);
				    break;
				case REGNUM:
				    t.type = (node->right)->w.type;
				    t.num = (node->right)->w.regnum;
				    temp_free(&t);
				    printf("\tST\tR%d,Var_%s\n",
					    (node->right)->w.regnum,
					    (node->left)->w.varname);
				    break;
			    }
			} else {
			    error("assignment target is not variable.");
			}
	    	    	break;
	    	    case '+':
			strcpy(op,"ADD");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '-':
			strcpy(op,"SUB");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '*':
			strcpy(op,"MUL");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '/':
			strcpy(op,"DIV");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
		}
		break;
	    case CONST:
	    case VARNAME:
	    	break;
	}
	return;
}

op_code_gen(op,node)
char	*op;
NODE	*node;
{
	TMP	t;
	NODE	*left,*right;

	left = node->left;
	right = node->right;
	switch (left->w.type) {
	    case CONST:
		switch (right->w.type) {
		    case CONST: /* const op const */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* const op const -> tmp */
			    printf("\t%s\t#%d,#%d,Tmp_T%d\n",
				    op,left->w.value,right->w.value,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* const op const -> reg */
			    printf("\t%s\t#%d,#%d,R%d\n",
				    op,left->w.value,right->w.value,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case VARNAME: /* const op var */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* const op var -> tmp */
			    printf("\t%s\t#%d,Var_%s,Tmp_T%d\n",
				    op,left->w.value,right->w.varname,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* const op var -> reg */
			    printf("\t%s\t#%d,Var_%s,R%d\n",
				    op,left->w.value,right->w.varname,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case TMPNUM: /* const op tmp */
			t.type = TMPNUM;
			t.num = right->w.tmpnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* const op tmp -> tmp */
			    printf("\t%s\t#%d,Tmp_T%d,Tmp_T%d\n",
				    op,left->w.value,right->w.tmpnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* const op tmp -> reg */
			    printf("\t%s\t#%d,Tmp_T%d,R%d\n",
				    op,left->w.value,right->w.tmpnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case REGNUM: /* const op reg */
			t.type = REGNUM;
			t.num = right->w.regnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* const op reg -> tmp */
			    printf("\t%s\t#%d,R%d,Tmp_T%d\n",
				    op,left->w.value,right->w.regnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* const op reg -> reg */
			    printf("\t%s\t#%d,R%d,R%d\n",
				    op,left->w.value,right->w.regnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		}
		break;
	    case VARNAME:
		switch (right->w.type) {
		    case CONST: /* var op const */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* var op const -> tmp */
			    printf("\t%s\tVar_%s,#%d,Tmp_T%d\n",
				    op,left->w.varname,right->w.value,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* var op const -> reg */
			    printf("\t%s\tVar_%s,#%d,R%d\n",
				    op,left->w.varname,right->w.value,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case VARNAME: /* var op var */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* var op var -> tmp */
			    printf("\t%s\tVar_%s,Var_%s,Tmp_T%d\n",
				    op,left->w.varname,right->w.varname,
				    t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* var op var -> reg */
			    printf("\t%s\tVar_%s,Var_%s,R%d\n",
				    op,left->w.varname,right->w.varname,
				    t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case TMPNUM: /* var op tmp */
			t.type = TMPNUM;
			t.num = right->w.tmpnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* var op tmp -> tmp */
			    printf("\t%s\tVar_%s,Tmp_T%d,Tmp_T%d\n",
				    op,left->w.varname,right->w.tmpnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* var op tmp -> reg */
			    printf("\t%s\tVar_%s,Tmp_T%d,R%d\n",
				    op,left->w.varname,right->w.tmpnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case REGNUM: /* var op reg */
			t.type = REGNUM;
			t.num = right->w.regnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* var op reg -> tmp */
			    printf("\t%s\tVar_%s,R%d,Tmp_T%d\n",
				    op,left->w.varname,right->w.regnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* var op reg -> reg */
			    printf("\t%s\tVar_%s,R%d,R%d\n",
				    op,left->w.varname,right->w.regnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		}
		break;
	    case TMPNUM:
		t.type = TMPNUM;
		t.num = left->w.tmpnum;
		temp_free(&t);
		switch (right->w.type) {
		    case CONST: /* tmp op const */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* tmp op const -> tmp */
			    printf("\t%s\tTmp_T%d,#%d,Tmp_T%d\n",
				    op,left->w.tmpnum,right->w.value,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* tmp op const -> reg */
			    printf("\t%s\tTmp_T%d,#%d,R%d\n",
				    op,left->w.tmpnum,right->w.value,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case VARNAME: /* tmp op var */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* tmp op var -> tmp */
			    printf("\t%s\tTmp_T%d,Var_%s,Tmp_T%d\n",
				    op,left->w.tmpnum,right->w.varname,
				    t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* tmp op var -> reg */
			    printf("\t%s\tTmp_T%d,Var_%s,R%d\n",
				    op,left->w.tmpnum,right->w.varname,
				    t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case TMPNUM: /* tmp op tmp */
			t.type = TMPNUM;
			t.num = right->w.tmpnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* tmp op tmp -> tmp */
			    printf("\t%s\tTmp_T%d,Tmp_T%d,Tmp_T%d\n",
				    op,left->w.tmpnum,right->w.tmpnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* tmp op tmp -> reg */
			    printf("\t%s\tTmp_T%d,Tmp_T%d,R%d\n",
				    op,left->w.tmpnum,right->w.tmpnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case REGNUM: /* tmp op reg */
			t.type = REGNUM;
			t.num = right->w.regnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* tmp op reg -> tmp */
			    printf("\t%s\tTmp_T%d,R%d,Tmp_T%d\n",
				    op,left->w.tmpnum,right->w.regnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* tmp op reg -> reg */
			    printf("\t%s\tTmp_T%d,R%d,R%d\n",
				    op,left->w.tmpnum,right->w.regnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		}
		break;
	    case REGNUM:
		t.type = REGNUM;
		t.num = left->w.regnum;
		temp_free(&t);
		switch (right->w.type) {
		    case CONST: /* reg op const */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* reg op const -> tmp */
			    printf("\t%s\tR%d,#%d,Tmp_T%d\n",
				    op,left->w.regnum,right->w.value,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* reg op const -> reg */
			    printf("\t%s\tR%d,#%d,R%d\n",
				    op,left->w.regnum,right->w.value,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case VARNAME: /* reg op var */
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* reg op var -> tmp */
			    printf("\t%s\tR%d,Var_%s,Tmp_T%d\n",
				    op,left->w.regnum,right->w.varname,
				    t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* reg op var -> reg */
			    printf("\t%s\tR%d,Var_%s,R%d\n",
				    op,left->w.regnum,right->w.varname,
				    t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case TMPNUM: /* reg op tmp */
			t.type = TMPNUM;
			t.num = right->w.tmpnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* reg op tmp -> tmp */
			    printf("\t%s\tR%d,Tmp_T%d,Tmp_T%d\n",
				    op,left->w.regnum,right->w.tmpnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* reg op tmp -> reg */
			    printf("\t%s\tR%d,Tmp_T%d,R%d\n",
				    op,left->w.regnum,right->w.tmpnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		    case REGNUM: /* reg op reg */
			t.type = REGNUM;
			t.num = right->w.regnum;
			temp_free(&t);
			get_temp(&t);
			node->w.type = t.type;
			if (t.type == TMPNUM) { /* reg op reg -> tmp */
			    printf("\t%s\tR%d,R%d,Tmp_T%d\n",
				    op,left->w.regnum,right->w.regnum,t.num);
			    node->w.tmpnum = t.num;
			} else {	      /* reg op reg -> reg */
			    printf("\t%s\tR%d,R%d,R%d\n",
				    op,left->w.regnum,right->w.regnum,t.num);
			    node->w.regnum = t.num;
			}
			break;
		}
		break;
	}
}

#ifdef SIMPLETMP
get_temp(t)
TMP	*t;
{
        static int tc = 0;

	if (tc < MAXREGNUM) {
	    t->type = REGNUM;
	    t->num = tc++;
	} else {
	    t->type = TMPNUM;
	    t->num = (tc++) - MAXREGNUM + 1;
	    tmp_touroku(t->num);
	}

}

temp_free(t)
TMP	*t;
{
}
#else
init_temp()
{
	int i;

	for (i = 0 ; i < MAXREGNUM ; i++) reguse[i] = FALSE;
	for (i = 1 ; i < MAXTMP ; i++) tmpuse[i] = FALSE;
}

get_temp(t)
TMP	*t;
{
	int i;

	if (called == FALSE) {
	    init_temp();
	    called = TRUE;
	}

	for (i = 0 ; i < MAXREGNUM ; i++) {
	    if (reguse[i] == FALSE) {
		reguse[i] = TRUE;
		t->type = REGNUM;
		t->num = i;
		return ;
	    }
	}
	for (i = 1 ; i < MAXTMP ; i++) {
	    if (tmpuse[i] == FALSE) {
		tmpuse[i] = TRUE;
		t->type = TMPNUM;
		t->num = i;
		tmp_touroku(t->num);
		return ;
	    }
	}
	error("temp area overflow");
}

temp_free(t)
TMP	*t;
{
	if (t->type == REGNUM) {
	    reguse[t->num] = FALSE;
	} else {
	    tmpuse[t->num] = FALSE;
	}
}
#endif
