#include <stdio.h>
#include "defines.h"

#define	MAXREGNUM 32

typedef struct {
	int	type;
	int	num;
} TMP ;

#ifndef SIMPLETMP
#define MAXTMP 50
static int called=FALSE;
static int reguse[MAXREGNUM];
static int tmpuse[MAXTMP];
#endif

code_gen(node)
NODE *node;
{
	TMP	t;
	char 	op[10];
	
	switch (node->w.type) {
	    case SYMBOL:
	    	switch (node->w.symbol) {
	    	    case '=':
	    	    	if ((node->left)->w.type==VARNAME) {
			    if ((node->right)->w.type == SYMBOL) {
				code_gen(node->right);
			    }
			    switch ((node->right)->w.type) {
				case CONST:
				    printf("\tLDI\t%d,R0\n",
					    (node->right)->w.value);
				    printf("\tST\tVar_%s,R0\n",
					    (node->left)->w.varname);
				    break;
				case VARNAME:
				    printf("\tLD\tVar_%s,R0\n",
					    (node->right)->w.varname);
				    printf("\tST\tVar_%s,R0\n",
					    (node->left)->w.varname);
				    break;
				case TMPNUM:
				    t.type = (node->right)->w.type;
				    t.num = (node->right)->w.tmpnum;
				    temp_free(&t);
				    printf("\tLD\tTmp_T%d,R0\n",
					    (node->right)->w.tmpnum);
				    printf("\tST\tVar_%s,R0\n",
					    (node->left)->w.varname);
				    break;
				case REGNUM:
				    t.type = (node->right)->w.type;
				    t.num = (node->right)->w.regnum;
				    temp_free(&t);
				    printf("\tST\tVar_%s,R%d\n",
					    (node->left)->w.varname,
					    (node->right)->w.regnum);
				    break;
			    }
			} else {
			    error("assignment target is not variable.");
			}
	    	    	break;
	    	    case '+':
			strcpy(op,"ADD");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '-':
			strcpy(op,"SUB");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '*':
			strcpy(op,"MUL");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
	    	    case '/':
			strcpy(op,"DIV");
			if ((node->left)->w.type == SYMBOL) {
			    code_gen(node->left);
			}
			if ((node->right)->w.type == SYMBOL) {
			    code_gen(node->right);
			}
			op_code_gen(op,node);
	    	    	break;
		}
		break;
	    case CONST:
	    case VARNAME:
	    	break;
	}
	return;
}

op_code_gen(op,node)
char	*op;
NODE	*node;
{
	switch ((node->left)->w.type) {
	    case CONST:
	    case VARNAME:
	    case TMPNUM:
		code_mixx(op,node);
		break;
	    case REGNUM:
		code_rxx(op,node);
		break;
	}
}

code_rxx(op,node) /* register op x -> x */
char *op;
NODE *node;
{
	TMP   t;
	NODE   *left,*right;

	left = node->left;
	right = node->right;

	t.type = left->w.type;
	t.num = left->w.regnum;
	temp_free(&t);
	switch (right->w.type) {
	    case VARNAME: /* R op M -> x */
		printf("\tLD\tVar_%s,R1\n",right->w.varname);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* R op M -> R */
			printf("\t%s\tR%d,R1,R%d\n",op,left->w.regnum,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* R op M -> M */
			printf("\t%s\tR%d,R1,R0\n",op,left->w.regnum);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case TMPNUM: /* R op M -> x */
		printf("\tLD\tTmp_T%d,R1\n",right->w.tmpnum);
		t.type = right->w.type;
		t.num = right->w.tmpnum;
		temp_free(&t);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* R op M -> R */
			printf("\t%s\tR%d,R1,R%d\n",op,left->w.regnum,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* R op M -> M */
			printf("\t%s\tR%d,R1,R0\n",op,left->w.regnum);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case REGNUM: /* R op R -> x */
		t.type = right->w.type;
		t.num = right->w.regnum;
		temp_free(&t);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* R op R -> R */
			printf("\t%s\tR%d,R%d,R%d\n",
				op,left->w.regnum,right->w.regnum,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* R op R -> M */
			printf("\t%s\tR%d,R%d,R0\n",
				op,left->w.regnum,right->w.regnum);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case CONST: /* R op I -> x */
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* R op I -> R */
			printf("\t%sI\tR%d,%d,R%d\n",
				op,left->w.regnum,right->w.value,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* R op I -> M */
			printf("\t%sI\tR%d,%d,R0\n",
				op,left->w.regnum,right->w.value);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	}
}

code_mixx(op,node) /* memory/immediate op x -> x */
char *op;
NODE *node;
{
	TMP    t;
	NODE   *left,*right;

	left = node->left;
	right = node->right;

	switch(left->w.type) {
	    case VARNAME:
		printf("\tLD\tVar_%s,R0\n",left->w.varname);
		break;
	    case TMPNUM:
		t.type = left->w.type;
		t.num = left->w.tmpnum;
		temp_free(&t);
		printf("\tLD\tTmp_T%d,R0\n",left->w.tmpnum);
		break;
	    case CONST:
		printf("\tLDI\t%d,R0\n",left->w.value);
		break;
	}
	switch (right->w.type) {
	    case VARNAME: /* M/I op M -> x */
		printf("\tLD\tVar_%s,R1\n",right->w.varname);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* M/I op M -> R */
			printf("\t%s\tR0,R1,R%d\n",op,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* M/I op M -> M */
			printf("\t%s\tR0,R1,R0\n",op);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case TMPNUM: /* M/I op M -> x */
		printf("\tLD\tTmp_T%d,R1\n",right->w.tmpnum);
		t.type = right->w.type;
		t.num = right->w.tmpnum;
		temp_free(&t);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* M/I op M -> R */
			printf("\t%s\tR0,R1,R%d\n",op,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* M/I op M -> M */
			printf("\t%s\tR0,R1,R0\n",op);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case REGNUM: /* M/I op R -> x */
		t.type = right->w.type;
		t.num = right->w.regnum;
		temp_free(&t);
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* M/I op R -> R */
			printf("\t%s\tR0,R%d,R%d\n",op,right->w.regnum,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* M/I op R -> M */
			printf("\t%s\tR0,R%d,R0\n",op,right->w.regnum);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	    case CONST: /* M/I op I -> x */
		get_temp(&t);
		node->w.type = t.type;
		switch (t.type) {
		    case REGNUM: /* M/I op I -> R */
			printf("\t%sI\tR0,%d,R%d\n",op,right->w.value,t.num);
			node->w.regnum = t.num;
			break;
		    case TMPNUM: /* M/I op I -> M */
			printf("\t%sI\tR0,%d,R0\n",op,right->w.value);
			printf("\tST\tTmp_T%d,R0\n",t.num);
			node->w.tmpnum = t.num;
			break;
		}
		break;
	}
}

#ifdef SIMPLETMP
get_temp(t)
TMP	*t;
{
        static int tc = 2;

	if (tc < MAXREGNUM) {
	    t->type = REGNUM;
	    t->num = tc++;
	} else {
	    t->type = TMPNUM;
	    t->num = (tc++) - MAXREGNUM + 1;
	    tmp_touroku(t->num);
	}

}

temp_free(t)
TMP	*t;
{
}
#else
init_temp()
{
	int i;

	for (i = 2 ; i < MAXREGNUM ; i++) reguse[i] = FALSE;
	for (i = 1 ; i < MAXTMP ; i++) tmpuse[i] = FALSE;
}

get_temp(t)
TMP	*t;
{
	int i;

	if (called == FALSE) {
	    init_temp();
	    called = TRUE;
	}

	for (i = 2 ; i < MAXREGNUM ; i++) {
	    if (reguse[i] == FALSE) {
		reguse[i] = TRUE;
		t->type = REGNUM;
		t->num = i;
		return ;
	    }
	}
	for (i = 1 ; i < MAXTMP ; i++) {
	    if (tmpuse[i] == FALSE) {
		tmpuse[i] = TRUE;
		t->type = TMPNUM;
		t->num = i;
		tmp_touroku(t->num);
		return ;
	    }
	}
	error("temp area overflow");
}

temp_free(t)
TMP	*t;
{
	if (t->type == REGNUM) {
	    reguse[t->num] = FALSE;
	} else {
	    tmpuse[t->num] = FALSE;
	}
}
#endif
