#include <stdio.h>
#include "defines.h"

code_gen(node)
NODE *node;
{
	switch (node->w.type) {
	    case CONST:
	    	printf("\tPUSHI\t%d\n",node->w.value);
	    	break;
	    case VARNAME:
	    	printf("\tPUSH\tVar_%s\n",node->w.varname);
	    	break;
	    case SYMBOL:
	    	switch (node->w.symbol) {
	    	    case '+':
	    	    	code_gen(node->left);
	    	    	code_gen(node->right);
	    	    	printf("\tADD\n");
	    	    	break;
	    	    case '-':
	    	    	code_gen(node->left);
	    	    	code_gen(node->right);
	    	    	printf("\tSUB\n");
	    	    	break;
	    	    case '*':
	    	    	code_gen(node->left);
	    	    	code_gen(node->right);
	    	    	printf("\tMUL\n");
	    	    	break;
	    	    case '/':
	    	    	code_gen(node->left);
	    	    	code_gen(node->right);
	    	    	printf("\tDIV\n");
	    	    	break;
	    	    case '=':
	    	    	if ((node->left)->w.type==VARNAME) {
			    code_gen(node->right);
			    printf("\tPOP\tVar_%s\n",
			    	    (node->left)->w.varname);
			} else {
			    error("assignment target is not variable.");
			}
	    	    	break;
		}
		break;
	}
	return;
}
