/* various architecture simulator ver.1.0 [92/Aug/26-] */
/* opcode -> mnemonic conversion tables */

#include "global.h"

/* mnemonic conv. table */

#ifdef ACCUM_ARCH
static char *mnemonic[4][8][2]=
	{ 
	  { {"LD","LDI"},{"ST","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"ADD","ADDI"},{"SUB","SUBI"},
	    {"MUL","MULI"},{"DIV","DIVI"},
	    {"AND","ANDI"},{"OR","ORI"},
	    {"XOR","XORI"},{"MOD","MODI"} } ,
	  { {"NEG","(undefined)"},
	    {"NOT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"NOP","(undefined)"},
	    {"HLT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } 
	} ;
#endif

#ifdef STACK_ARCH
static char *mnemonic[4][8][2]=
	{ 
	  { {"PUSH","PUSHI"},{"POP","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"ADD","(undefined)"},{"SUB","(undefined)"},
	    {"MUL","(undefined)"},{"DIV","(undefined)"},
	    {"AND","(undefined)"},{"OR","(undefined)"},
	    {"XOR","(undefined)"},{"MOD","(undefined)"} } ,
	  { {"NEG","(undefined)"},
	    {"NOT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"NOP","(undefined)"},
	    {"HLT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } 
	} ;
#endif

#ifdef CISC_ARCH
static char *mnemonic[4][8][2]=
	{ 
	  { {"LD","MOV"},{"ST","MOV"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"ADD","ADD"},{"SUB","SUB"},
	    {"MUL","MUL"},{"DIV","DIV"},
	    {"AND","AND"},{"OR","OR"},
	    {"XOR","XOR"},{"MOD","MOD"} } ,
	  { {"NEG","(undefined)"},
	    {"NOT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"NOP","(undefined)"},
	    {"HLT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } 
	} ;
#endif

#ifdef RISC_ARCH
static char *mnemonic[4][8][2]=
	{ 
	  { {"LD","LDI"},{"ST","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"ADD","ADDI"},{"SUB","SUBI"},
	    {"MUL","MULI"},{"DIV","DIVI"},
	    {"AND","ANDI"},{"OR","ORI"},
	    {"XOR","XORI"},{"MOD","MODI"} } ,
	  { {"NEG","NEGI"},
	    {"NOT","NOTI"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } ,
	  { {"NOP","(undefined)"},
	    {"HLT","(undefined)"},
	    {"(undefined)","(undefined)"},
	    {"(undefined)","(undefined)"}, } 
	} ;
#endif
