/* various architecture simulator ver.1.0 [92/Aug/26-] */
/* define constants & struct typedefs.   */

#include "global.h"

/* constant defines */
#undef	TRUE
#undef	FALSE
#define TRUE	1
#define FALSE	0

/* define architecture */
#define CISC_ARCH

/* Status String LENgth */
#define SSLEN	256

/* register size */
#ifdef ACCUM_ARCH
#define REGSIZE	1	/* ACCUM arch. register size = 1 (accumlator) */
#endif
#ifdef STACK_ARCH
#define REGSIZE	0	/* STACK arch. hos no register */
#endif
#ifdef CISC_ARCH
#define REGSIZE	8	/* CISC arch. register size = 8 */
#endif
#ifdef RISC_ARCH
#define REGSIZE	32	/* RISC arch. register size = 32 */
#endif

/* memory size */
#define MEMSIZE	65536	/* memory size */

/* word type defines */

typedef short	word;
typedef int	doubleword;

/* struct type defines */

typedef struct {
	int	address;
	int	optype;
	int	subtype;
	int	src1flag;
	int	src1;
	int	src2flag;
	int	src2;
	int	dstnflag;
	int	dstn;
} decoded_inst;

#ifdef STACK_ARCH
struct stack_struct {
	word	val;
	struct	stack_struct	*next;
} ;

typedef	struct stack_struct	stack;
#endif
