/* accumlator architecture simulator ver.1.0 [92/Aug/26-] */
/* object program loader */

#include <stdio.h>

#include "defines.h"
#include "cmnvar.h"
#include "opcode.h"
#include "display.h"
#include "debugger.h"

int progload(filename)
char	*filename;
{
	FILE	*objfile;
	int	addr;
	int	object;
	char	loadfile[256];
	char	linebuff[256];

	addr = 0 ;	/* default program start addr = 0 */

	if (strcmp(filename+strlen(filename)-4,".obj")==0) {
		strcpy(loadfile,filename);
	} else { /* no filename extention '.obj' */
		strcpy(loadfile,filename);
		strcat(loadfile,".obj");/* append extention */
	}

	if ((objfile = fopen(loadfile,"r")) == NULL) {
		mvprintw (COMMANDLINE+2,0,"%s not found.",loadfile);
		dispflush();
		return(FALSE);
	}

	mvprintw(COMMANDLINE+2,0,"Loading... ");
	dispflush();

	while(fgets(linebuff,256,objfile) != NULL) {
		if (linebuff[0] == ':') { /* address */
			sscanf(linebuff,":%x",&addr);
#ifdef DEBUG
			fprintf (stderr,"progload: addr = %04X\n",addr & 0xffff);
#else
			printw("%04X ",addr & 0xffff);
			dispflush();
#endif
		} else { /* object code */
			sscanf(linebuff,"%x",&object);
			memory[addr] = object;
#ifdef DEBUG
			fprintf (stderr,"progload: memory[%04X] = %04X\n",addr & 0xffff,memory[addr] & 0xffff);
#endif
			addr++;
		}
	}

	fclose(objfile);

#ifdef DEBUG
	gets(linebuff);	/* wait for return key input */
#else
	printw(stderr,"done.");
	dispflush();
#endif

	return (TRUE);
}
