/* architecture simulator ver.1.0 [92/Aug./26-] */
/* simulation main routine */

#include "defines.h"
#include "cmnvar.h"
#include "opcode.h"
#include "extfunc.h"

#include "debugger.h"

simulate()
{
	decoded_inst	inst;
	word		nextpc;

	while (haltflag	!= TRUE) {
	    /* increment simulation cycle */
	    cycle++;

	    /* decode instruction */
	    nextpc = decode(PC,&inst);

	    /* run-time error check */
	    if (errorflag == TRUE) break;

	    /* execute decoded instruction */
	    execinst(&inst);

	    /* display simulator status */
	    display(cycle);

	    /* set new PC */
	    PC = nextpc;

	    /* run-time error check */
	    if (errorflag == TRUE) break;

	    /* breakpoint check */
	    if (checkbreakpoint(PC) == TRUE) return BREAK_STOP;

	    /* keyboard interrupt check */
	    if (interruptflag == TRUE)  {
		interruptflag = FALSE;
		return INTERRUPT;
	    }
	}
	/* simulation end by HALT instruction */
        if (haltflag == TRUE) return HALT_END;
	/* simulation end by ERROR */
        if (errorflag == TRUE) return ERROR_END;
}
